/*
!=======================================================================
!
!  PROGRAM  PHASE-Viewer  (PHASE-Viewer 2014.01 ver.3.3.0)
!
!  Created on 2006/02/09, 15:06
!  AUTHOR(S): KOGA, Junichiro
!  File : FileState.java
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!=======================================================================
 */

package ciss.phase_viewer.inputinterface.filestate;

import java.io.File;

import org.apache.log4j.Logger;

/**
 * ファイルの状態を表すクラス
 * 
 * @author
 */
public class FileState {
    /**
     * 当該ファイルには特になにも変化がない場合これを指定
     */
    public static int FILE_NO_CHANGE = 0;
    /**
     * 当該ファイルが生成された場合これを指定
     */
    public static int FILE_CREATED = 1;
    /**
     * 当該ファイルが削除されていた場合これを指定
     */
    public static int FILE_REMOVED = 2;
    /**
     * 当該ファイルが編集された場合これを指定
     */
    public static int FILE_MODIFIED = 3;

    private Logger logger = Logger.getLogger(FileState.class.getName());

    private int fileState = FILE_NO_CHANGE;
    private File file;

    /**
     * 対応するファイルを指定.
     * 
     * @param file
     *            対応するファイル
     */
    public FileState(File file) {
        this.file = file;
    }

    /**
     * ファイル状態と対応するファイルを指定する.
     * 
     * @param file
     *            対応するファイル
     * @param fileState
     *            対応するファイルの状態
     */
    public FileState(File file, int fileState) {
        this.file = file;
        this.fileState = fileState;
    }

    /**
     * 今のファイルの状態を取得
     * 
     * @return 当該ファイルの状態
     */
    public int getFileState() {
        return this.fileState;
    }

    /**
     * このオブジェクトに関連付けられたファイルそのものを返す.
     * 
     * @return このクラスに関連付けられたファイル
     */
    public File getFile() {
        return this.file;
    }

    /**
     * このクラスに関連付けられているFileオブジェクトのlastModifiedメソッドを呼ぶ
     * (getFile().lastModified()と同じ)
     * 
     * @return このクラスに関連付けられているファイルの更新日時
     */
    public long lastModified() {
        return this.file.lastModified();
    }

    /**
     * このオブジェクトの持っている「ファイル」が同じかどうかを判定する
     * 
     * @param obj
     *            比較したいFileStateオブジェクト
     * @return 引数が同じファイルを指している場合true
     */
    public boolean equals(Object obj) {
        if (!(obj instanceof FileState)) {
            return false;
        }
        FileState state = (FileState) obj;
        return state.getFile().equals(file);
    }

    public String toString() {
        String ret = "file : " + file.getAbsolutePath();
        if (fileState == FILE_REMOVED) {
            ret += " state: removed";
        }
        if (fileState == FILE_CREATED) {
            ret += " state: created";
        }
        if (fileState == FILE_MODIFIED) {
            ret += " state: modified";
        }
        return ret;
    }
}
